#ifndef MY_DIM
#error MY_DIM unset
#endif

#include "../explicitgrid.hh"
#include "../explicitvectors.hh"

#include <dune/solvers/solvers/loopsolver.hh>

#include "../../dune/tectonic/globalfriction.hh"
#include "tnnmg/functional.hh"
#include "tnnmg/zerononlinearity.hh"
#include "solverfactory.hh"

using MyGlobalFriction = GlobalFriction<Matrix, Vector>;
using MyFunctional = Functional<Matrix&, Vector&, MyGlobalFriction&, Vector&, Vector&, double>;
using MyZeroFunctional = Functional<Matrix&, Vector&, ZeroNonlinearity&, Vector&, Vector&, double>;
using MySolverFactory = SolverFactory<MyFunctional, BitVector>;

using MyLinearSolver = Dune::Solvers::LoopSolver<Vector, BitVector>;

using MySolverFactory = SolverFactory<MyFunctional, BitVector>;
template class SolverFactory<MyFunctional, BitVector>;

/*template<> SolverFactory<MyFunctional, BitVector>::SolverFactory(Dune::ParameterTree const &,
                                                               MyFunctional&,
                                                               MyLinearSolver&&,
                                                               const BitVector&);*/

template class SolverFactory<MyZeroFunctional, BitVector>;

/*template<>
template<> SolverFactory<MyZeroFunctional, BitVector>::SolverFactory(Dune::ParameterTree const &,
                                                               MyZeroFunctional&,
                                                               MyLinearSolver&&,
                                                               const BitVector&);*/
